function varargout = image_GUI(varargin)
% IMAGE_GUI M-file for image_GUI.fig
%      IMAGE_GUI, by itself, creates a new IMAGE_GUI or raises the existing
%      singleton*.
%
%      H = IMAGE_GUI returns the handle to a new IMAGE_GUI or the handle to
%      the existing singleton*.
%
%      IMAGE_GUI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in IMAGE_GUI.M with the given input arguments.
%
%      IMAGE_GUI('Property','Value',...) creates a new IMAGE_GUI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before image_GUI_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to image_GUI_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help image_GUI

% Last Modified by GUIDE v2.5 18-Jun-2005 11:12:20

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @image_GUI_OpeningFcn, ...
                   'gui_OutputFcn',  @image_GUI_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin & isstr(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT

warning off all

% --- Executes just before image_GUI is made visible.
function image_GUI_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to image_GUI (see VARARGIN)

% Choose default command line output for image_GUI
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

if nargin == 3,
    initial_dir = pwd;
elseif nargin > 4
    if strcmpi(varargin{1},'dir')
        if exist(varargin{2},'dir')
            initial_dir = varargin{2};
        else
            errordlg('Input argument must be a valid directory','Input Argument Error!')
            return
        end
    else
        errordlg('Unrecognized input argument','Input Argument Error!');
        return;
    end
end
% Populate the listbox
load_listbox(initial_dir,handles)
% Return figure handle as first output argument
    
% UIWAIT makes lbox2 wait for user response (see UIRESUME)
% uiwait(handles.figure1);

% UIWAIT makes image_GUI wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = image_GUI_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;



% --- Executes on button press in pushbutton2.
function pushbutton2_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

index_selected = get(handles.listbox1,'Value');
file_list = get(handles.listbox1,'String');	
filename = file_list{index_selected};
[path,name,ext,ver] = fileparts(filename);
switch ext
    case '.jpg'
    X = imread(filename);
   
    
    figure('Name',filename,'NumberTitle','off');
    imshow(X)

    hold on
    [x,y]=ginput(1);
    plot(x,y,'rs')
    hold off

    set(handles.edit4,'String',x)
    set(handles.edit5,'String',y)


    R = X(y,x,1);
    G = X(y,x,2);
    B = X(y,x,3);
   

    r=double(R)/255;
    g=double(G)/255;
    b=double(B)/255;
    
   
case '.bmp'
    
    format = imfinfo(filename);
    
    if (strcmp(format.ColorType,'indexed') )
    
    [Y,map]=imread(filename);
   
    figure('Name',filename,'NumberTitle','off');
    imshow(Y,map)
    
    [n m]=size(Y);
    
    hold on
    [x,y]=ginput(1);
    plot(x,y,'rs')
    hold off
    

    set(handles.edit4,'String',x)
    set(handles.edit5,'String',y)


    
    % Save the pixels in the window
    [m n]=size(Y);

    if ((x+5<n)&(x-5>0)&(y+5<m) & (y-5>0))
        P = double(Y(y-5:y+5,x-5:x+5));
    end
    
    block = 255*(map(P+1,1)+map(P+1,2)+map(P+1,3))/3;
        
    
    r = map(p+1,1);
    g = map(p+1,2);
    b = map(p+1,3);
    
    R = uint8(r*255);
    G = uint8(g*255);
    B = uint8(b*255);
    
    S = ones(110,110);

    for i=1:11
        for j = 1:11
    
        S(1 + (i-1)*10:i*10,1 + (j-1)*10:j*10)=P(i,j)+1;
    
        end
    end



    axes(handles.axes6)
    imshow(S,map);
    
    elseif (strcmp(format.ColorType,'truecolor') )
        
        X = imread(filename);
   
    
    figure('Name',filename,'NumberTitle','off');
    imshow(X)

    hold on
    [x,y]=ginput(1);
    plot(x,y,'rs')
    hold off
   

    set(handles.edit4,'String',x)
    set(handles.edit5,'String',y)
    
 
    
    % Save the pixels in the window
    m = size(X,1);
    n = size(X,2);
    

    if ((x+5<n)&(x-5>0)&(y+5<m) & (y-5>0))
        P = double(X(y-5:y+5,x-5:x+5,:));
        block = (P(:,:,1)+ P(:,:,2)+ P(:,:,3))/3;
        block = block(:);
    end
        
    x = uint8(x);
    y = uint8(y);
   

    R = X(y,x,1);
    G = X(y,x,2);
    B = X(y,x,3);
   

    r=double(R)/255;
    g=double(G)/255;
    b=double(B)/255;
    
    
    
    for i=1:11
        for j = 1:11
    
        S(1 + (i-1)*10:i*10,1 + (j-1)*10:j*10,1)=uint8(P(i,j,1));
        S(1 + (i-1)*10:i*10,1 + (j-1)*10:j*10,2)=uint8(P(i,j,2));
        S(1 + (i-1)*10:i*10,1 + (j-1)*10:j*10,3)=uint8(P(i,j,3));
    
        end
    end

   

    axes(handles.axes6)
    imshow(S);
        
    end
    
    
    
       
case '.tif'
    [Z,map2]=imread(filename);
    figure('Name',filename,'NumberTitle','off');
    imshow(Z,map2)
    
    hold on
    [x,y]=ginput(1);
    plot(x,y,'rs')
    hold off

    set(handles.edit4,'String',x)
    set(handles.edit5,'String',y)

    p = double(Z(y,x));

    r = map2(p+1,1);
    g = map2(p+1,2);
    b = map2(p+1,3);
    
    R = uint8(r*255);
    G = uint8(g*255);
    B = uint8(b*255);
        
end

I = uint8(255*(r+g+b)/3);

set(handles.edit7,'String',I)



M = sum(block)/121;
V = sum((block-M).^2)/121;
V = sqrt(V);

set(handles.edit8,'String',floor(M))
set(handles.edit9,'String',floor(V))

set(handles.edit1,'String',R)
set(handles.edit2,'String',G)
set(handles.edit3,'String',B)

%Plots a square with the selected pixel values
Q = ones(50,50,3);
Q(:,:,1)=r;
Q(:,:,2)=g;
Q(:,:,3)=b;

% Plots the 11 x 11 window with the 121 pixels in the surrounding of the
% selected pixe



axes(handles.axes2)
imshow(Q);



% --- Executes during object creation, after setting all properties.
function edit1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end



function edit1_Callback(hObject, eventdata, handles)
% hObject    handle to edit1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit1 as text
%        str2double(get(hObject,'String')) returns contents of edit1 as a double


% --- Executes during object creation, after setting all properties.
function edit2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end



function edit2_Callback(hObject, eventdata, handles)
% hObject    handle to edit2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit2 as text
%        str2double(get(hObject,'String')) returns contents of edit2 as a double


% --- Executes during object creation, after setting all properties.
function edit3_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end



function edit3_Callback(hObject, eventdata, handles)
% hObject    handle to edit3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit3 as text
%        str2double(get(hObject,'String')) returns contents of edit3 as a double


% --- Executes during object creation, after setting all properties.
function edit4_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end



function edit4_Callback(hObject, eventdata, handles)
% hObject    handle to edit4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit4 as text
%        str2double(get(hObject,'String')) returns contents of edit4 as a double


% --- Executes during object creation, after setting all properties.
function edit5_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end



function edit5_Callback(hObject, eventdata, handles)
% hObject    handle to edit5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit5 as text
%        str2double(get(hObject,'String')) returns contents of edit5 as a double


% --- Executes during object creation, after setting all properties.
function listbox1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to listbox1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


% --- Executes on selection change in listbox1.
function listbox1_Callback(hObject, eventdata, handles)
% hObject    handle to listbox1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns listbox1 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from listbox1

get(handles.figure1,'SelectionType');
if strcmp(get(handles.figure1,'SelectionType'),'open')
	index_selected = get(handles.listbox1,'Value');
	file_list = get(handles.listbox1,'String');	
	filename = file_list{index_selected};
	if  handles.is_dir(handles.sorted_index(index_selected))
		cd (filename)
		load_listbox(pwd,handles)
	else
	   [path,name,ext,ver] = fileparts(filename);
	   switch ext
	   case '.fig'
		   guide (filename)
       case '.jpg'
        axes(handles.axes1)
        title(filename)
        imshow(filename);
        case '.bmp'
        axes(handles.axes1)
        title(filename)
        imshow(filename);
        case '.tif'
        axes(handles.axes1)
        title(filename)
        imshow(filename);
           
	   otherwise 
		try
	    	open(filename)
		catch
			errordlg(lasterr,'File Type Error','modal')
		end
	   end	
   end
end

% ------------------------------------------------------------
% Read the current directory and sort the names
% ------------------------------------------------------------
function load_listbox(dir_path,handles)
cd (dir_path)
dir_struct = dir(dir_path);
[sorted_names,sorted_index] = sortrows({dir_struct.name}');
handles.file_names = sorted_names;
handles.is_dir = [dir_struct.isdir];
handles.sorted_index = [sorted_index];
guidata(handles.figure1,handles)
set(handles.listbox1,'String',handles.file_names,...
	'Value',1)




% --- Executes on button press in pushbutton3.
function pushbutton3_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
index_selected = get(handles.listbox1,'Value');
file_list = get(handles.listbox1,'String');	
filename = file_list{index_selected};


format = imfinfo(filename);
if (strcmp(format.ColorType,'indexed')) 

    [Y,map]=imread(filename);

    valR = red(Y,map);
    valG = green(Y,map);
    valB = blue(Y,map);

    
elseif (strcmp(format.ColorType,'truecolor') )
     X = imread(filename);
     valR = X(:,:,1);
     valR = valR(:);
     valG = X(:,:,2);
     valG = valG(:);
     valB = X(:,:,3);
     val = valB(:);
end
    
figure('Name','RedHistogram','NumberTitle','off','Color',[1 0 0]);
imhist(valR);
figure('Name','GreenHistogram','NumberTitle','off','Color',[0 1 0]);
imhist(valG);
figure('Name','BlueHistogram','NumberTitle','off','Color',[0 0 1]);
imhist(valB);


function edit7_Callback(hObject, eventdata, handles)
% hObject    handle to edit7 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit7 as text
%        str2double(get(hObject,'String')) returns contents of edit7 as a double


% --- Executes during object creation, after setting all properties.
function edit7_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit7 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit8_Callback(hObject, eventdata, handles)
% hObject    handle to edit8 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit8 as text
%        str2double(get(hObject,'String')) returns contents of edit8 as a double


% --- Executes during object creation, after setting all properties.
function edit8_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit8 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit9_Callback(hObject, eventdata, handles)
% hObject    handle to edit9 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit9 as text
%        str2double(get(hObject,'String')) returns contents of edit9 as a double


% --- Executes during object creation, after setting all properties.
function edit9_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit9 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


